﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using Advantage.Data.Provider;
using System.Collections;

namespace CSharpNotifications
{
  class EmployeeNotification
  {
    // Volatile informs the compiler that _terminated
    // can be accessed by multiple threads.
    private volatile bool _terminated;
    private AdsConnection connection;
    private AdsCommand command;
    private String connName;
    private delegate void UpdateListBoxDelegate(ArrayList aList);
    public EmployeeNotification(string connString, string cName)
    {
      connName = cName;
      connection = new AdsConnection(connString);
      connection.Open();
      command = connection.CreateCommand();
      command.CommandText = "EXECUTE PROCEDURE sp_CreateEvent('EmployeeChanged', 2);";
      command.ExecuteNonQuery();
    }

    // This method will be called when the thread is started.
    public void DoWork()
    {
      try
      {
        AdsDataReader dataReader;
        command.CommandText =
          "EXECUTE PROCEDURE sp_WaitForEvent('EmployeeChanged', 1000, 0, 2);";
        while (!_terminated)
        {
          dataReader = command.ExecuteReader();
          try
          {
            if (_terminated) break;
            dataReader.Read();
            if (dataReader.GetString(2).StartsWith("terminate") ) continue;
            ArrayList aList = new ArrayList();
            char[] splitchar = { '|' };
            do
            {
              //there has been a notification   
              String[] p = dataReader.GetString(2).Split(splitchar);
              if (p[0] == connName)
              {
                aList.Add("Employee " + p[2] + " was " + p[1] + " by you");
              }
              else
              {
                aList.Add("Employee " + p[2] + " was " + p[1] + " by someone else");
              }
            } while (!dataReader.Read());
            //pass the 
            MainForm.me.listBox1.Invoke(new UpdateListBoxDelegate(MainForm.me.UpdateListbox), aList);
          }
          finally
          {
            dataReader.Close();
          }
        } // while (!_terminated)
      }
      finally
      {
        command.CommandText = "EXECUTE PROCEDURE sp_DropEvent('EmployeeChanged', 2)";
        command.ExecuteNonQuery();
        connection.Close();
      }
    }

    public void Terminate()
    {
      _terminated = true;
    }

  }
}

